#include "importwindow.h"
#include "ui_importwindow.h"

ImportWindow::ImportWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::ImportWindow)
{
    ui->setupUi(this);
    CancelImport=false;
    setWindowFlags(Qt::WindowTitleHint);
}

ImportWindow::~ImportWindow()
{
    delete ui;
}

void ImportWindow::_setMainWindow(MainWindow* x){
    mainWindow=x;
}

void ImportWindow::_setButtonText(QString text){
    ui->pushButton->setText(text);
}

void ImportWindow::_clearAll(){
    ui->done->setPlainText("");
    ui->failed->setPlainText("");
    ui->inDB->setPlainText("");
}

void ImportWindow::_setText(QString x){
    ui->label->setText(x);
}

void ImportWindow::_setStatus(QString x){
    ui->label_2->setText(x);
}

void ImportWindow::zeige(){
    this->show();
    ui->pushButton->setEnabled(true);
}

void ImportWindow::_setStatusProgressbar(int x){
    ui->progressBar->setValue(x);
}

void ImportWindow::_addSuccess(QString suc){
    ui->done->appendPlainText(suc);
}

void ImportWindow::_addError(QString err){
    ui->failed->appendPlainText(err);
}

void ImportWindow::_addDBEntry(QString db){
    ui->inDB->appendPlainText(db);
}

void ImportWindow::_setTime(int x){
    QString time;
    if(x>86400){
        time=QString::number(x/86400)+" Tage";
        x-=86400*x/86400;
    }
    if(x>3600){
        time+=" "+QString::number(x/3600)+" Stunden";
        x-=3600*x/3600;
    }
    if(x>60){
        time+=" "+QString::number(x/60)+" Minuten";
        x-=60*x/60;
    }
    if(x>0){
        time+=time+" "+QString::number(x)+" Sekunden";
    }
    if(time=="")
        time=" ???";
    ui->label_3->setText("Verbleibende Zeit: ~"+time);
}

void ImportWindow::cancelProgress(){
    CancelImport=true;
    _setText("Import wird abgebrochen");
    _setStatus("Vorgang abbrechen");
    ui->pushButton->setDisabled(true);
}

void ImportWindow::on_pushButton_clicked(){
    cancelProgress();
}
