#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QMessageBox>

QSqlDatabase db;
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    ui->pushButton_2->setDisabled(true);
    ui->pushButton_3->setDisabled(true);
    ui->actionVorlese_Optionen->setDisabled(true);
    RatingStars.append(QCoreApplication::applicationDirPath());
    RatingStars.append("/Data/Images/sternNotRated.jpg");
    RatingStars.append("/Data/Images/stern0.jpg");
    RatingStars.append("/Data/Images/stern1.jpg");
    RatingStars.append("/Data/Images/stern2.jpg");
    RatingStars.append("/Data/Images/stern3.jpg");
    RatingStars.append("/Data/Images/stern4.jpg");
    RatingStars.append("/Data/Images/stern5.jpg");
    tempRead=QCoreApplication::applicationDirPath()+"/Data/tempRead";
    XMLs=QCoreApplication::applicationDirPath()+"/Data/XMLs";
    GenreSettings=QCoreApplication::applicationDirPath()+"/Data/Settings/GenreSettings.ini";
    Settings=QCoreApplication::applicationDirPath()+"/Data/Settings/Settings.ini";
    qApp->installEventFilter(this);
    db =  QSqlDatabase::addDatabase("QSQLITE");
    db.setDatabaseName(QCoreApplication::applicationDirPath()+"/Data/Resources/Buecher.sqlite");
    db.open();
    _SqlExec("CREATE TABLE IF NOT EXISTS `Buecher`(`ID` INTERGER,`Identifier` TEXT,`author` TEXT,`description` TEXT,`subject` TEXT,`title` TEXT,`date` TEXT,`path` TEXT,`language` TEXT,`rating` TEXT)");
    QStringList Combo1_items;
    Combo1_items<<"Alle"<<"ID"<<"Identifikationsnummer"<<"Autor"<<"Beschreibung"<<"Genre"
                <<"Name"<<"Erstelldatum"<<"Dateipfad"<<"Sprache"<<"Bewertung";
    ui->comboBox->addItems(Combo1_items);
    ui->treeWidget->setUniformRowHeights(true);
    ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(1)+"' />");
    aktImage=ui->RateImage->text();
    ui->RateBG->setStyleSheet("QLabel { background-color: black }");
    ui->RateImage_no->setText("<img src='"+RatingStars.at(0)+RatingStars.at(1)+"' />");
    ui->RateImage_s0->setText("<img src='"+RatingStars.at(0)+RatingStars.at(2)+"' />");
    ui->RateImage_s1->setText("<img src='"+RatingStars.at(0)+RatingStars.at(3)+"' />");
    ui->RateImage_s2->setText("<img src='"+RatingStars.at(0)+RatingStars.at(4)+"' />");
    ui->RateImage_s3->setText("<img src='"+RatingStars.at(0)+RatingStars.at(5)+"' />");
    ui->RateImage_s4->setText("<img src='"+RatingStars.at(0)+RatingStars.at(6)+"' />");
    ui->RateImage_s5->setText("<img src='"+RatingStars.at(0)+RatingStars.at(7)+"' />");
    ui->RateBG->hide();
    ui->RateImage->hide();
    ui->RateImage_no->hide();
    ui->RateImage_s0->hide();
    ui->RateImage_s1->hide();
    ui->RateImage_s2->hide();
    ui->RateImage_s3->hide();
    ui->RateImage_s4->hide();
    ui->RateImage_s5->hide();
    this->show();
    importWindow=new ImportWindow;
    importWindow->hide();
    QSettings settings(Settings, QSettings::IniFormat);
    QString x=settings.value("General/LoadAllAtBegin","false").toString();
    if(settings.value("General/LoadGenreCounts","false").toString()=="true"){
        showBookCount=true;
    }
    else{
        showBookCount=false;
    }
    if(settings.value("General/openIntern","false").toString()=="true"){
        openIntern=true;
    }
    else{
        openIntern=false;
    }
    QFuture<void> future = QtConcurrent::run(this, &MainWindow::_fillListWidget);
    if(x=="true"){
        QFuture<void> future = QtConcurrent::run(this, &MainWindow::_getSqlArrayMT,QString("Select ID,title,author,subject,rating,path,language from Buecher where 1 ORDER BY title ASC;"));
        //QList<QStringList> erg=_getSqlArray("Select ID,title,author,subject,rating,path,language from Buecher where 1;");
        //QFuture<void> future = QtConcurrent::run(this, &MainWindow::_fillListView,erg,false,false);
        //_fillListView(erg,false,false);
    }
}

MainWindow::~MainWindow()
{
    db.close();
    delete ui;
}

void MainWindow::closeEvent( QCloseEvent *event ) {
    importWindow->cancelProgress();
    qApp->quit();
    event->accept();
}

void MainWindow::mousePressEvent ( QMouseEvent * event )
{
    if(selected && event->button()==1){
        QPoint pos=event->pos();
        int i=20;
        if(pos.x()>=1650 && pos.x()<=1877 && pos.y()>=40+i && pos.y()<=85+i && !popup){
            on_RateImage_clicked();
        }
        else if(popup && pos.x()>=1650 && pos.x()<=1877 && pos.y()>85+i && pos.y()<=400+i){
            on_RateImageU_clicked(pos.y()-i);
        }
        else{
            if(popup){
                ui->RateBG->hide();
                ui->RateImage_no->hide();
                ui->RateImage_s0->hide();
                ui->RateImage_s1->hide();
                ui->RateImage_s2->hide();
                ui->RateImage_s3->hide();
                ui->RateImage_s4->hide();
                ui->RateImage_s5->hide();
                popup=false;
            }
        }
    }
}

bool MainWindow::eventFilter(QObject *obj, QEvent *event)
{
  if (event->type() == QEvent::MouseMove)
  {
    QMouseEvent *mouseEvent = static_cast<QMouseEvent*>(event);
    mouseMoveEvent(mouseEvent);
  }
  return false;
}

void MainWindow::mouseMoveEvent(QMouseEvent *event)
{
    if(popup){
        QPoint pos=event->pos();
        QPoint wpos=this->pos();
        //QSize wsize=this->size();
        int i=50;
        int x=event->globalX()-wpos.x();
        int y=event->globalY()-wpos.y();
        if(x>=1650 && wpos.x()+x<=1877 && y>=85+i && y<=400+i){
            ImageHovered(wpos.y()+pos.y()-i+30);
        }
        else{
            //_msg(QString::number(x)+" "+QString::number(y));
            if(aktImage!=ui->RateImage->text()){
                ui->RateImage->setText(aktImage);
            }
        }
    }
}

void MainWindow::ImageHovered(int HoverY){
    if(HoverY>85 && HoverY<=130){
        if("<img src='"+RatingStars.at(0)+RatingStars.at(1)+"' />"!=ui->RateImage->text())
            ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(1)+"' />");
    }
    else if(HoverY>130 && HoverY<=175){
        if("<img src='"+RatingStars.at(0)+RatingStars.at(2)+"' />"!=ui->RateImage->text())
            ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(2)+"' />");
    }
    else if(HoverY>175 && HoverY<=220){
        if("<img src='"+RatingStars.at(0)+RatingStars.at(3)+"' />"!=ui->RateImage->text())
            ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(3)+"' />");
    }
    else if(HoverY>220 && HoverY<=265){
        if("<img src='"+RatingStars.at(0)+RatingStars.at(4)+"' />"!=ui->RateImage->text())
            ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(4)+"' />");
    }
    else if(HoverY>265 && HoverY<=310){
        if("<img src='"+RatingStars.at(0)+RatingStars.at(5)+"' />"!=ui->RateImage->text())
            ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(5)+"' />");
    }
    else if(HoverY>310 && HoverY<=355){
        if("<img src='"+RatingStars.at(0)+RatingStars.at(6)+"' />"!=ui->RateImage->text())
            ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(6)+"' />");
    }
    else if(HoverY>355 && HoverY<=400){
        if("<img src='"+RatingStars.at(0)+RatingStars.at(7)+"' />"!=ui->RateImage->text())
            ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(7)+"' />");
    }
}

void MainWindow::on_RateImage_clicked(){
    ui->RateBG->show();
    ui->RateImage_no->show();
    ui->RateImage_s0->show();
    ui->RateImage_s1->show();
    ui->RateImage_s2->show();
    ui->RateImage_s3->show();
    ui->RateImage_s4->show();
    ui->RateImage_s5->show();
    popup=true;
}

void MainWindow::on_RateImageU_clicked(int y){
    QString rating;
    if(y>85 && y<=130){
        ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(1)+"' />");
        rating="";
    }
    else if(y>130 && y<=175){
        ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(2)+"' />");
        rating="0";
    }
    else if(y>175 && y<=220){
        ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(3)+"' />");
        rating="1";
    }
    else if(y>220 && y<=265){
        ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(4)+"' />");
        rating="2";
    }
    else if(y>265 && y<=310){
        ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(5)+"' />");
        rating="3";
    }
    else if(y>=310 && y<=355){
        ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(6)+"' />");
        rating="4";
    }
    else if(y>=355 && y<=400){
        ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(7)+"' />");
        rating="5";
    }
    QTreeWidgetItem *item=ui->treeWidget->currentItem();
    _SqlExec("UPDATE Buecher SET rating = '"+rating+"' WHERE id='"+item->text(0)+"'");
    item->setText(4,rating);
    aktImage=ui->RateImage->text();
    ui->RateBG->hide();
    ui->RateImage_no->hide();
    ui->RateImage_s0->hide();
    ui->RateImage_s1->hide();
    ui->RateImage_s2->hide();
    ui->RateImage_s3->hide();
    ui->RateImage_s4->hide();
    ui->RateImage_s5->hide();
    popup=false;
}

void MainWindow::on_comboBox_currentIndexChanged(const QString &arg1)
{

}

void MainWindow::on_comboBox_2_currentIndexChanged(int index)
{

}

void MainWindow::on_pushButton_clicked()
{
    int Where=ui->comboBox->currentIndex();
    int how=ui->comboBox_2->currentIndex();
    QString search=ui->lineEdit->text();
    //_msg(search+" in "+QString::number(Where)+" with "+QString::number(how));
    QString howstart=" like '%";
    QString howend="%'";
    if(how!=0){
        howstart="='";
        howend="'";
    }
    QString bedingung;
    QStringList cause;
    QString bed;
    switch(Where){
        case 0:
            cause<<"ID"<<"Identifier"<<"author"<<"description"<<"subject"<<"title"<<"date"<<"path"
                 <<"language"<<"rating";
            foreach(QString item,cause){
                bed+=item+howstart+search+howend+" or ";
            }
            bedingung=bed.left(bed.length()-4);;
            break;
        case 1:
            bedingung="ID"+howstart+search+howend;
            break;
        case 2:
            bedingung="Identifier"+howstart+search+howend;
            break;
        case 3:
            bedingung="author"+howstart+search+howend;
            break;
        case 4:
            bedingung="description"+howstart+search+howend;
            break;
        case 5:
            bedingung="subject"+howstart+search+howend;
            break;
        case 6:
            bedingung="title"+howstart+search+howend;
            break;
        case 7:
            bedingung="date"+howstart+search+howend;
            break;
        case 8:
            bedingung="path"+howstart+search+howend;
            break;
        case 9:
            bedingung="language"+howstart+search+howend;
            break;
        case 10:
            bedingung="rating"+howstart+search+howend;
            break;
    }
    QList<QStringList> erg=_getSqlArray("Select ID,title,author,subject,rating,path,language from Buecher where "+bedingung+" ORDER BY title ASC;");
    _fillListView(erg,false,false);
}

void MainWindow::on_listWidget_itemClicked(QListWidgetItem *item)
{
    _ListWidgetChanged();
}

void MainWindow::_ListWidgetChanged(){
    QStringList selectedListWidget;
    QList<QListWidgetItem *> selected=ui->listWidget->selectedItems();
    foreach (QListWidgetItem * item, selected){
        QString tm=item->text();
        if(showBookCount&&tm!="Alle"){
            QStringList tmp=tm.split(" - ");
            tm="";
            for(int i=0;i<tmp.count()-1;i++){
                tm+=tmp.at(i);
            }
        }
        selectedListWidget.append(tm);
    }
    if(selectedListWidget.count()==0){
        ui->treeWidget->clear();
    }
    _fillTreeWithList(selectedListWidget);
///*
    //if(x->SqlLoadingThread.isRunning()){
    //    x->SqlLoadingThread.cancel();
    //}
    //ui->listWidget->setEnabled(false);
    //QFuture<void> future = QtConcurrent::run(this, &MainWindow::_fillTreeWithList,selectedListWidget);
    //while(!future.isFinished()){
    //    QCoreApplication::processEvents();
    //    Sleep(10);
    //}
    //ui->listWidget->setEnabled(true);
    //QFuture watchFuture=QFutureWatcher();
    //QFuture future=QFuture();
    //QtConcurrent::
    //QList<QStringList> list;
    //list.append(selectedListWidget);
    //SqlLoadingThread=QtConcurrent::map(selectedListWidget,this,&MainWindow::_fillTreeWithList);
    //x->SqlLoadingThread=QtConcurrent::map(selectedListWidget,&MainWindow::_fillTreeWithList);
    //SqlLoadingThread=QtConcurrent::map(list, &MainWindow::_fillTreeWithList());
    //x->SqlLoadingThread=QtConcurrent::map(list,&MainWindow::_fillTreeWithList);
    //SqlLoadingThread=QtConcurrent::map(list, [this] (QStringList& data) { _fillTreeWithList(data); });
    //SqlLoadingThread=QtConcurrent::map(list,[this](QStringList selectedListWidget){_fillTreeWithList(selectedListWidget);});
    //SqlLoadingThread = QtConcurrent::run(this,&MainWindow::_fillTreeWithList,selectedListWidget);
    //QtConcurrent::mappedReduced(QList,function, ReduceFunction reduceFunction, QtConcurrent::ReduceOptions reduceOptions = UnorderedReduce | SequentialReduce)
    //QFuture<QHash<QString, int> >counting =  mappedReduced(list, mapFunction, reduceFunction);
//*/
}

void MainWindow::on_listWidget_itemDoubleClicked(QListWidgetItem *item)
{
    on_treeWidgetContextRead();
}

void MainWindow::on_pushButton_2_clicked()
{

}

void MainWindow::on_pushButton_3_clicked()
{

}

void MainWindow::_fillListWidget(){
    ui->listWidget->clear();
    QSettings settings(GenreSettings, QSettings::IniFormat);
    settings.beginGroup("Genres");
    const QStringList KeyNames = settings.allKeys();
    foreach (const QString &childKey, KeyNames){
        if(showBookCount){
            QSettings settings(GenreSettings, QSettings::IniFormat);
            settings.beginGroup("Genres");
            QString tmp=settings.value(childKey).toString();
            settings.endGroup();
            QList<QStringList> count=_getSqlArray("Select count(id) from Buecher where "+tmp+";");
            QString x;
            for(int i = 0; i < count[0].count() ; i++){
                for(int j = 0; j < count.count() ; j++){
                    x=count[j][i];
                }
            }
            MainWindow::ui->listWidget->addItem(childKey+" - ("+x+")");
        }
        else{
            MainWindow::ui->listWidget->addItem(childKey);
        }
    }
    ui->listWidget->sortItems();
    ui->listWidget->insertItem(0, "Alle");
    settings.endGroup();
}

void MainWindow::_fillListView(QList<QStringList> list,bool headers=false,bool changeSize=false){
    ui->treeWidget->setUpdatesEnabled(false);
    ui->treeWidget->clear();
    ui->treeWidget->setColumnCount(list.count());
    if (!headers){
        QTreeWidgetItem *Head = new QTreeWidgetItem(0);
        for(int i=0;i<list.count();i++){
            switch(i){
                case 0:
                    ui->treeWidget->setColumnWidth(0,0);
                    Head->setText(i, "Id");
                    break;
                case 1:
                    ui->treeWidget->setColumnWidth(1,300);
                    Head->setText(i, "Name");
                    break;
                case 2:
                    ui->treeWidget->setColumnWidth(2,180);
                    Head->setText(i, "Autor");
                    break;
                case 3:
                    ui->treeWidget->setColumnWidth(3,150);
                    Head->setText(i, "Genre");
                    break;
                case 4:
                    ui->treeWidget->setColumnWidth(4,180);
                    Head->setText(i, "Bewertung");
                    break;
                case 5:
                    ui->treeWidget->setColumnWidth(5,350);
                    Head->setText(i, "Pfad");
                    break;
                case 6:
                    ui->treeWidget->setColumnWidth(6,50);
                    Head->setText(i, "Sprache");
                    break;
                default:
                    ui->treeWidget->setColumnWidth(i,100);
                    Head->setText(i, "?"+QString::number(i));
                    break;
            }
        }
        ui->treeWidget->setHeaderItem(Head);
    }
    else{
        QTreeWidgetItem *Head = new QTreeWidgetItem(0);
        for(int i=0;i<list.count();i++){
            switch(i){
                default:
                    ui->treeWidget->setColumnWidth(i,100);
                    Head->setText(i, "?"+QString::number(i));
                    break;
            }
        }
        ui->treeWidget->setHeaderItem(Head);
    }
    for(int i = 0; i < list[0].count() ; i++){
        QTreeWidgetItem *testItem = new QTreeWidgetItem(ui->treeWidget);
        for(int j = 0; j < list.count() ; j++){
            testItem->setText(j, QString(list[j][i]));
            QSize size=testItem->sizeHint(j);
            size.setHeight(20);
            testItem->setSizeHint(j,size);
        }
        ui->treeWidget->addTopLevelItem(testItem);
    }
    ui->Label_Eintrag->setText("Einträge in der Liste: "+QString::number(list[0].count()));
    ui->treeWidget->setUpdatesEnabled(true);
}

void MainWindow::_fillTreeWithList(QStringList selListWidget){
    QString subject;
    QSettings settings(GenreSettings, QSettings::IniFormat);
    settings.beginGroup("Genres");
    foreach(QString item,selListWidget){
    //for(int i=0;i<selListWidget.count();i++){
        //QString item=selListWidget.at(i);
        QString tmp;
        if(item!="Alle"){
            tmp=settings.value(item).toString();
        }
        if(tmp!="")
           subject+=tmp+" or ";
        if(item=="Alle"){
           subject="Alle or ";
           break;
        }
    }
    subject=subject.left(subject.length()-4);
    settings.endGroup();
    //_msg(lastSqlSubject+"!="+subject);
    if(lastSqlSubject!=subject){
        lastSqlSubject=subject;
        if(subject!="" && subject=="Alle"){
            QList<QStringList> erg=_getSqlArray("Select ID,title,author,subject,rating,path,language from Buecher where 1 ORDER BY title ASC;");
            _fillListView(erg);
        }
        else if(subject!=""){
            QList<QStringList> erg=_getSqlArray("Select ID,title,author,subject,rating,path,language from Buecher where "+subject+" ORDER BY title ASC;");
            _fillListView(erg);
        }
    }
}

void MainWindow::_getSqlArrayMT(QString Sql){
    QList<QStringList> List;
    QStringList   fieldName;
    QSqlQuery query(Sql);
    QSqlRecord rec = query.record();
    for( int i=0; i<rec.count(); ++i )
            fieldName << rec.fieldName( i );
   foreach( QString str, fieldName ){
    QStringList tmpList;
    while( query.next() ){
        tmpList << query.value(rec.indexOf( str )).toString();
    }
    query.seek(-1);  // since next at end - start at top again for next pass
    List << tmpList;
   }
   _fillListView(List,false,false);
}

QList<QStringList>  MainWindow::_getSqlArray(QString Sql){
    QList<QStringList> List;
    QStringList   fieldName;
    QSqlQuery query(Sql);
    QSqlRecord rec = query.record();
    for( int i=0; i<rec.count(); ++i )
            fieldName << rec.fieldName( i );
   foreach( QString str, fieldName ){
    QStringList tmpList;
    while( query.next() ){
        tmpList << query.value(rec.indexOf( str )).toString();
    }
    query.seek(-1);  // since next at end - start at top again for next pass
    List << tmpList;
   }
   return List;
}

void MainWindow::_SqlExec(QString Sql){
    //_msg(Sql);
    QSqlQuery query;
    if(!query.exec(Sql)){
        _msg("Sql-Error while running: "+Sql);
    }
}

void MainWindow::_msg(QString msg){
    QMessageBox::warning(this,"Debugging", msg, "Ok");
}

void MainWindow::_Error(QString msg){
    QMessageBox::warning(this,"Fehler", "Fehler: "+msg, "Ok");
}

void MainWindow::on_treeWidget_itemClicked(QTreeWidgetItem *item, int column)
{
    QList<QStringList> list=_getSqlArray("Select author,title,date,path,subject,Identifier,language,rating,description from Buecher where id='"+item->text(0)+"'");
    for(int i = 0; i < list[0].count() ; i++){
        ui->label_Autor->setText(QString(list[0][i]));
        ui->label_Autor->setToolTip(QString(list[0][i]));
        ui->label_Buchname->setText(QString(list[1][i]));
        ui->label_Buchname->setToolTip(QString(list[1][i]));
        ui->label_ErstellDatum->setText(QString(list[2][i]));
        ui->label_ErstellDatum->setToolTip(QString(list[2][i]));
        QStringList name=QString(list[3][i]).split("\\");
        ui->label_Filename->setText(name.last());
        ui->label_Filename->setToolTip(name.last());
        ui->label_Genre->setText(QString(list[4][i]));
        ui->label_Genre->setToolTip(QString(list[4][i]));
        ui->label_Ident->setText(QString(list[5][i]));
        ui->label_Ident->setToolTip(QString(list[5][i]));
        ui->label_language->setText(QString(list[6][i]));
        ui->label_language->setToolTip(QString(list[6][i]));
        ui->label_Path->setText(QString(list[3][i]));
        ui->label_Path->setToolTip(QString(list[3][i]));
        ui->textEdit->setText(QString(list[8][i]));
        QStringList Rates;
        Rates<<""<<"0"<<"1"<<"2"<<"3"<<"4"<<"5";
        switch(Rates.indexOf(list[7][i])){
            case 0:
                ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(1)+"' />");
                break;
            case 1:
                ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(2)+"' />");
                break;
            case 2:
                ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(3)+"' />");
                break;
            case 3:
                ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(4)+"' />");
                break;
            case 4:
                ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(5)+"' />");
                break;
            case 5:
                ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(6)+"' />");
                break;
            case 6:
                ui->RateImage->setText("<img src='"+RatingStars.at(0)+RatingStars.at(7)+"' />");
                break;
        }
        selected=true;
        ui->RateImage->show();
    }
}

void MainWindow::_openBook(QTreeWidgetItem* item,int opt=-1){
    QString path=_getTreeWidgetItemGlobalPath(item);
    if(!QFileInfo::exists(path.replace("\\","/"))){
        _Error("Das Buch existiert nicht.");
        return;
    }
    if(opt==-1){
        if(openIntern){
            //open with Reader (later)
            QString program = QCoreApplication::applicationDirPath()+"/Reader.exe";
            QStringList arguments;
            arguments << path.replace(" ","%20%");
            QProcess *myProcess = new QProcess();
            myProcess->start(program, arguments);
        }
        else{
            QDesktopServices::openUrl("file:///"+path.replace("\\","/"));
        }
    }
    else{
        //#if defined(Q_OS_WIN)
        const QString explorer = "explorer";
        QStringList param;
        if (!QFileInfo(path).isDir())
            param << QLatin1String("/select,");
        param << QDir::toNativeSeparators(path);
        QProcess::startDetached(explorer, param);
        //#elif defined(Q_OS_MAC)
        /*
            QStringList scriptArgs;
            scriptArgs << QLatin1String("-e")
                   << QString::fromLatin1("tell application \"Finder\" to reveal POSIX file \"%1\"")
                                         .arg(path);
            QProcess::execute(QLatin1String("/usr/bin/osascript"), scriptArgs);
            scriptArgs.clear();
            scriptArgs << QLatin1String("-e")
                   << QLatin1String("tell application \"Finder\" to activate");
            QProcess::execute("/usr/bin/osascript", scriptArgs);
         * */
    }
}

QString MainWindow::_getTreeWidgetItemGlobalPath(QTreeWidgetItem* item){
    QList<QStringList> list=_getSqlArray("Select path from Buecher where id='"+item->text(0)+"'");
    QString path;
    for(int i = 0; i < list[0].count() ; i++){
        path=list[0][i];
        if(path.startsWith("\\")){
            QString Dir=qApp->applicationDirPath();
            Dir=Dir.replace("/","\\");
            path = Dir+path;
        }
        return path;
    }
}

void MainWindow::on_treeWidgetContextRead(){
    QTreeWidgetItem* sel=ui->treeWidget->currentItem();
    if(!sel==NULL){
        _openBook(sel);
    }
}
void MainWindow::on_treeWidgetContextOpen(){
    QTreeWidgetItem* sel=ui->treeWidget->currentItem();
    if(!sel==NULL){
        bool tmp=openIntern;
        openIntern=false;
        _openBook(sel);
        openIntern=tmp;
    }
}
void MainWindow::on_treeWidgetContextOpenFolder(){
    QTreeWidgetItem* sel=ui->treeWidget->currentItem();
    if(!sel==NULL){
        _openBook(sel,0);
    }
}
void MainWindow::on_treeWidgetContextEdit(){
    QTreeWidgetItem* sel=ui->treeWidget->currentItem();
    if(!sel==NULL){
        editWindow=new EditWindow;
        editWindow->show();
        editWindow->_setSelected(sel->text(0).toLong(),this,sel);
    }
}
void MainWindow::on_treeWidgetContextCopyPath(){
    QTreeWidgetItem* sel=ui->treeWidget->currentItem();
    if(!sel==NULL){
        QString path=_getTreeWidgetItemGlobalPath(sel);
        QApplication::clipboard()->setText(path);
    }
}
void MainWindow::on_treeWidgetContextDeleteDB(){
    QTreeWidgetItem* sel=ui->treeWidget->currentItem();
    if(!sel==NULL){
        int reply=QMessageBox::question(this,"Sicherheitsabfrage","Möchten sie das Buch \""+sel->text(1)+"\" wirklich aus der Datenbank löschen?",QMessageBox::Yes|QMessageBox::No);
        if(reply==QMessageBox::Yes){
            //_msg("delete from Buecher where id="+sel->text(0));
            _SqlExec("delete from Buecher where id="+sel->text(0));
        }
    }
    delete sel;
}
void MainWindow::on_treeWidgetContextDelete(){
    QTreeWidgetItem* sel=ui->treeWidget->currentItem();
    if(!sel==NULL){
        QString path=_getTreeWidgetItemGlobalPath(sel);
        path=path.replace("\\","/");
        int reply=QMessageBox::question(this,"Sicherheitsabfrage","Möchten sie das Buch \""+sel->text(1)+"\" wirklich vom Computer löschen?",QMessageBox::Yes|QMessageBox::No);
        if(reply==QMessageBox::Yes){
            _SqlExec("delete from Buecher where id="+sel->text(0));
            QFile file(path);
            file.remove();
        }
    }
    delete sel;
}

void MainWindow::on_treeWidget_customContextMenuRequested(const QPoint &pos)
{
    QMenu *menu=new QMenu(this);
    menu->addAction(QString("Lesen"), this,SLOT(on_treeWidgetContextRead()));
    menu->addAction(QString("Öffnen"), this,SLOT(on_treeWidgetContextOpen()));
    menu->addAction(QString("Öffne den Ordner, der das Buch enthält"), this,SLOT(on_treeWidgetContextOpenFolder()));
    menu->addAction(QString("Bearbeiten"), this,SLOT(on_treeWidgetContextEdit()));
    menu->addAction(QString("Kopiere Pfad in Zwischenablage"), this,SLOT(on_treeWidgetContextCopyPath()));
    menu->addAction(QString("Lösche das Buch aus der Datenbank"), this,SLOT(on_treeWidgetContextDeleteDB()));
    menu->addAction(QString("Entferne das Buch vom Computer"), this,SLOT(on_treeWidgetContextDelete()));
    menu->popup(ui->treeWidget->viewport()->mapToGlobal(pos));
}

void MainWindow::on_treeWidget_itemSelectionChanged()
{
    on_treeWidget_itemClicked(ui->treeWidget->currentItem(),0);
}

void MainWindow::on_actionLesen_triggered()
{
    on_treeWidgetContextRead();
}

void MainWindow::on_actionAlleB_cher_aus_der_Datenbank_entfernen_triggered()
{
    int reply=QMessageBox::question(this,"Sicherheitsabfrage","Möchten sie wirklich alle Bücher aus der Datenbank enfernen?",QMessageBox::Yes|QMessageBox::No);
    if(reply==QMessageBox::Yes){
        _SqlExec("Delete from Buecher where 1");
    }
    _ListWidgetChanged();
    QFuture<void> future = QtConcurrent::run(this, &MainWindow::_fillListWidget);
}

void MainWindow::on_action_ndere_alle_B_cher_zum_kompletten_Pfad_triggered()
{
    int reply=QMessageBox::question(this,"Sicherheitsabfrage","Möchten sie wirklich die Pfade aller Bücher global setzen?",QMessageBox::Yes|QMessageBox::No);
    if(reply==QMessageBox::Yes){
        QList<QStringList> list=_getSqlArray("Select id,path from Buecher where 1");
        QString x;
        QString AppPath=QCoreApplication::applicationDirPath().replace("/","\\");
        QString path;
        for(int i = 0; i < list[0].count() ; i++){
            if(!list[1][i].contains(AppPath)){
                path=AppPath+list[1][i];
                if(QFile(path.replace("\\","/")).exists())
                    _SqlExec("UPDATE Buecher SET path=\""+AppPath+list[1][i]+"\" WHERE id='"+list[0][i]+"'");
            }
        }
    }
    _ListWidgetChanged();
}

void MainWindow::on_action_ndere_den_Pfad_aller_B_cher_wenn_m_glich_zu_einem_Pfad_relativ_zum_Programm_triggered()
{
    int reply=QMessageBox::question(this,"Sicherheitsabfrage","Möchten sie wirklich die Pfade aller Bücher relativ zum Programm setzen?",QMessageBox::Yes|QMessageBox::No);
    if(reply==QMessageBox::Yes){
        QList<QStringList> list=_getSqlArray("Select id,path from Buecher where 1");
        QString x;
        QString AppPath=QCoreApplication::applicationDirPath().replace("/","\\");
        QString path;
        for(int i = 0; i < list[0].count() ; i++){
            QCoreApplication::processEvents();
            if(list[1][i].contains(AppPath)){
                path=list[1][i].replace(AppPath,"");
                _SqlExec("UPDATE Buecher SET path=\""+list[1][i]+"\" WHERE id='"+list[0][i]+"'");
            }
        }
    }
    _ListWidgetChanged();
}

void MainWindow::on_action_ndere_den_Pfad_aller_B_cher_notfalls_mit_verschieben_triggered()
{
    int reply=QMessageBox::question(this,"Sicherheitsabfrage","Möchten sie wirklich die Pfade aller Bücher relativ zum Programm setzen?",QMessageBox::Yes|QMessageBox::No);
    if(reply==QMessageBox::Yes){
        QList<QStringList> list=_getSqlArray("Select id,path from Buecher where 1");
        QString x;
        QString AppPath=QCoreApplication::applicationDirPath().replace("/","\\");
        QString path;
        for(int i = 0; i < list[0].count() ; i++){
            QCoreApplication::processEvents();
            if(list[1][i].contains(AppPath)){
                path=list[1][i].replace(AppPath,"");
                _SqlExec("UPDATE Buecher SET path=\""+list[1][i]+"\" WHERE id='"+list[0][i]+"'");
            }
            else{
                QList<QString> x=list[1][i].replace("\\","/").split("/");
                QDir r;
                r.rename(list[1][i].replace("\\","/"),AppPath+"/Data/Buecher/"+x.last());
                path=list[1][i].replace(AppPath,"");
                _SqlExec("UPDATE Buecher SET path=\"\\Data\\Buecher\\"+x.last()+"\" WHERE id='"+list[0][i]+"'");
            }
        }
    }
    _ListWidgetChanged();
}

void MainWindow::on_actionSQL_Konsole_vorsichtig_nutzen_triggered()
{
    SQL_KONSOLE=new SQL_Konsole(this);
    SQL_KONSOLE->setWin(this);
    SQL_KONSOLE->show();
}

void MainWindow::_importFolder(){
    QString FolderPath=QFileDialog::getExistingDirectory(this,"Wähle Ordner",QCoreApplication::applicationDirPath()+"/Data/Buecher");
    if(FolderPath!=""){
        QDir* dir=new QDir;
        importWindow->_clearAll();
        importWindow->_setStatusProgressbar(0);
        importWindow->zeige();
        importWindow->CancelImport=false;
        importWindow->_setText("Bitte warten! Speicherort der XMLS wird geleert!");
        clearImportFolders();
        importWindow->_setText("Bitte warten! Durchsuche Ordner nach Dateien!");
        importWindow->_setStatus("Suche nach Dateien");
        importWindow->_setTime(0);
        QStringList x=_getFiles(FolderPath);
        if(!importWindow->CancelImport){
            _import(x);
        }
        else{
            importWindow->hide();
        }
    }
}

void MainWindow::_importFiles(){
    QStringList files=QFileDialog::getOpenFileNames(this,"Wähle ein oder mehrere Bücher",QCoreApplication::applicationDirPath()+"/Data/Buecher","Bücher (*.epub)");
    if(files.count()>0){
        importWindow->_clearAll();
        importWindow->_setStatusProgressbar(0);
        importWindow->zeige();
        importWindow->CancelImport=false;
        importWindow->_setText("Bitte warten! Speicherort der XMLS wird geleert!");
        clearImportFolders();
        _import(files);
    }
}

void MainWindow::clearImportFolders(){
    QDir* dir=new QDir;
    dir->setPath(XMLs);
    dir->removeRecursively();
    dir->mkdir(XMLs);
    dir->setPath(tempRead);
    dir->removeRecursively();
    dir->mkdir(tempRead);
}

void MainWindow::_import(QStringList files){
    importWindow->_setText("Bitte warten! Dateien werden extrahiert!");
    importWindow->_setStatus("0/"+files.count(QString()));
    double onePercent=(double)files.count()/100;
    int aktNumber=0;
    int aktPercent=0;
    int count=files.count();
    importWindow->_setStatusProgressbar(aktPercent);
    QTime Timer;
    Timer.start();
    QString InDB="Bereits erfasst:";
    QString Failed="Fehlgeschlagen:";
    QFile Error(XMLs+"/error.dat");
    Error.open(QIODevice::WriteOnly|QIODevice::Text);
    QTextStream ErrorS(&Error);
    QFile Log(XMLs+"/log.dat");
    Log.open(QIODevice::WriteOnly|QIODevice::Text);
    QTextStream LogS(&Log);
    QString completePath;
    QDir r;
    foreach(QString path,files){
        completePath=path;
        QStringList lPath=path.split("/");
        if(lPath.last().split(".").last()!="epub"){
            Failed+=QString::fromStdString("\n")+QString::fromStdString("Kein Epub: ")+path;
            ErrorS << "Kein epub: "+path+"\n";
            importWindow->_addError("Kein epub: "+path);
        }
        else{
            QList<QStringList> counts=_getSqlArray("Select count(id) from Buecher where path LIKE '%"+lPath.last().replace("'","`")+"%' ");
            if(counts.last().last().toInt()>0){
                InDB+="\n"+path;
                ErrorS << "Bereits erfasst: "+path+"\n";
                importWindow->_addError("Bereits erfasst: "+path);
            }
            else{
                QString newPath=path.mid(0,path.lastIndexOf(".")).mid(path.lastIndexOf("/"));
                r.mkdir(tempRead);
                int Time=0;
                if(aktNumber==0){
                    Time=30;
                }
                else{
                    Time=Timer.elapsed()/aktNumber/1000*10;
                }
                if(_unzip(path,newPath,Time)){
                    QFile file(tempRead+newPath+"/META-INF/container.xml");
                    if(file.open(QIODevice::ReadOnly)) {
                        QTextStream in(&file);
                        QString text = in.readAll();
                        QStringList x=text.split("<rootfile full-path=\"");
                        if(x.count()<2){
                            Failed+="Fehlerhafte container.xml: "+path;
                            ErrorS << "Fehlerhafte container.xml: "+path+"\n";
                            importWindow->_addError("Fehlerhafte container.xml: "+path);
                        }
                        else{
                            x=x.at(1).split("\"");
                            if(x.count()>1&&x.at(0)!=""){
                                file.copy(tempRead+newPath+"/"+x.at(0),XMLs+"/"+newPath+".xml");
                                if(aktNumber!=0){
                                    LogS << "\n";
                                }
                                LogS << newPath.replace("/","")+"#|#|#"+completePath;
                                importWindow->_addSuccess("Erfolgreich hinzugefügt: "+path);
                            }
                            else{
                                Failed+="Fehlerhafte container.xml: "+path;
                                ErrorS << "Fehlerhafte container.xml: "+path+"\n";
                                importWindow->_addError("Fehlerhafte container.xml: "+path);
                            }
                        }
                    }
                    else{
                        Failed+="Keine container.xml gefunden: "+path;
                        ErrorS << "Keine container.xml gefunden: "+path+"\n";
                        importWindow->_addError("Keine container.xml gefunden: "+path);
                    }
                    file.close();
                }
                else{
                    Failed+="Fehler beim entpacken: "+path;
                    ErrorS << "Fehler beim entpacken: "+path+"\n";
                    importWindow->_addError("Fehler beim entpacken: "+path);
                }
                if(!importWindow->CancelImport)
                    importWindow->zeige();
                r.setPath(tempRead);
                r.removeRecursively();
                r.rmdir(tempRead);
            }
        }
        aktNumber++;
        QCoreApplication::processEvents();
        if(onePercent!=0&&(aktNumber/onePercent)!=aktPercent){
            aktPercent=aktNumber/onePercent;
            importWindow->_setStatusProgressbar(aktPercent);
        }
        importWindow->_setStatus(QString::number(aktNumber)+"/"+QString::number(count));
        importWindow->_setTime(Timer.elapsed()/aktNumber*(count-aktNumber)/1000);
        if(importWindow->CancelImport){
            break;
        }
    }
    Error.close();
    Log.close();
    if(importWindow->CancelImport){
        importWindow->hide();
    }
    else{
        importWindow->_setStatusProgressbar(100);
        _importToDb();
    }
}

bool MainWindow::_unzip(QString PathFrom,QString PathTo,int time){
    if(time<10){
        time=10;
    }
    //_msg(PathFrom+" to "+PathTo);
    QString program = QCoreApplication::applicationDirPath()+"/Data/Tools/7zG.exe";

    QStringList arguments;
    arguments << QString()+"x"<<"-y"<<"-o"+tempRead.replace("/","\\")+PathTo.replace("/","\\")<<PathFrom.replace("/","\\");
    QProcess *myProcess = new QProcess();
    myProcess->start(program, arguments);
    int count=0;
    while(!myProcess->waitForFinished(100) && count<int(time*10)){
        QCoreApplication::processEvents();
        count++;
    }
    if(count>=int(time*10)){
        myProcess->kill();
        return false;
    }
    /*
    SHELLEXECUTEINFO shellExInfo;
    shellExInfo.cbSize = sizeof(SHELLEXECUTEINFO);
    shellExInfo.fMask = SEE_MASK_NOCLOSEPROCESS;
    shellExInfo.hwnd = NULL;
    shellExInfo.lpVerb = (LPCTSTR)"open";
    shellExInfo.lpFile = program.toStdWString().c_str();
    shellExInfo.lpParameters = (QString()+"x "+"-y "+"-o\""+tempRead.replace("/","\\")+PathTo.replace("/","\\")+"\" \""+PathFrom.replace("/","\\")+"\"").toStdWString().c_str();
    shellExInfo.lpDirectory = NULL;
    shellExInfo.nShow = SW_HIDE;
    shellExInfo.hInstApp = NULL;
    //ShellExecute(0, (LPCTSTR)"open", (LPCTSTR)program,(LPCTSTR)QString()+"x "<<"-y "<<"-o\""+tempRead.replace("/","\\")+PathTo.replace("/","\\")+"\" \""+PathFrom.replace("/","\\")+"\"", NULL, SW_HIDE);
    ShellExecuteEx(&shellExInfo);
    int count=0;
    while(!WaitForSingleObject(shellExInfo.hProcess,100) && count<int(time*10)){
        QCoreApplication::processEvents();
        count++;
    }
    if(count>=int(time*10)){
        TerminateProcess(shellExInfo.hProcess, 1);
        return false;
    }*/
    /*QZip* zipFile=new QZip(path,newPath);
    zipFile->unzip();
    QFile *file=new QFile;
    file->setFileName(newPath+"/META-INF/container.xml");
    file->open(QIODevice::ReadOnly);
    QTextStream in(file);
    _msg(in.readAll());*/
    return true;
}

QStringList MainWindow::_getFiles(QString path){
    QDir* dir=new QDir(path);
    QStringList files;
    QStringList folders=dir->entryList(QDir::Dirs);
    foreach(QString folder,folders){
        QCoreApplication::processEvents();
        if(importWindow->CancelImport){
            break;
        }
        if(folder!="."&&folder!=".."){
            QList<QString> x=_getFiles(path+"/"+folder);
            foreach(QString l,x){
                files.append(l);
            }
        }
    }
    QList<QString> x=dir->entryList(QDir::Files);
    foreach(QString l,x){
        QCoreApplication::processEvents();
        if(importWindow->CancelImport){
            break;
        }
        files.append(path+"/"+l);
    }
    return files;
}

void MainWindow::_importToDb(){
    importWindow->_setText("Bitte warten! Dateien werden in Datenbank eingetragen!");
    importWindow->_setStatus("0/0");
    importWindow->_setStatusProgressbar(0);
    QFile file(XMLs+"/log.dat");
    if(file.open(QIODevice::ReadOnly)) {
        QTextStream in(&file);
        QString text = in.readAll();
        QStringList x=text.split("\n");
        x.removeAll("");
        int count=x.count();
        double onePercent=(double)count/100;
        int aktNumber=0;
        int aktPercent=0;
        importWindow->_setStatusProgressbar(aktPercent);
        QTime Timer;
        Timer.start();
        importWindow->_setStatus("0/"+QString::number(count));
        QList<QStringList> counts=_getSqlArray("Select MAX(id) from Buecher where 1");
        int id=counts.last().last().toInt()+1;
        foreach(QString str,x){
            if(str!=""){
                QFile aktfile(XMLs+"/"+str.split("#|#|#").at(0)+".xml");
                if(aktfile.open(QIODevice::ReadOnly)){
                    QTextStream in2(&aktfile);
                    QString data = in2.readAll();
                    QString author=_firstStringBetween(data,"<dc:creator", "/dc:creator>");
                    QString desc=_firstStringBetween(data,"<dc:description", "/dc:description>");
                    QString title=_firstStringBetween(data,"<dc:title", "/dc:title>");
                    QString date=_firstStringBetween(data, "<dc:date", "/dc:date>");
                    QString ident=_firstStringBetween(data,"<dc:identifier", "/dc:identifier>");
                    QString subj=_firstStringBetween(data,"<dc:subject", "/dc:subject>");
                    QString lan=_firstStringBetween(data,"<dc:language", "/dc:language>");
                    QString path=str.split("#|#|#").at(1);
                    path.replace("/","\\");
                    if(ident!="" && (author=="" || title=="" || subj=="" || desc=="")){
                        QStringList items=_getBookInfosByISBN(ident);
                        if(author=="")
                            author=items.at(0);
                        if(title=="")
                            title=items.at(1);
                        if(subj=="")
                            subj=items.at(2);
                        if(desc==""){
                            desc=items.at(3);
                        }
                    }
                    if(path.at(path.length()-1)==char(13)||path.at(path.length()-1)==char(10)){
                        path=path.left(path.length()-1);
                    }
                    _SqlExec(QString()+"INSERT INTO `Buecher`(`ID`,`Identifier`,`author`,`description`,`title`,`subject`,`date`,`path`,`language`) VALUES ('"
                             + QString::number(id+aktNumber) + "','" + ident + "','" + author + "','" + desc + "','" + title + "','" + subj + "','"
                             + date + "'," + "\"" + path + "\"" + ",'" + lan + "')");
                    importWindow->_addDBEntry(QString()+"Hinzugefügt: "+title+" Pfad: "+str.split("#|#|#").at(1));
                }
                else{
                    importWindow->_addError("Konnte nicht zur Datenbank hinzugefügt werden: "+str.split("#|#|#").at(1));
                }
                aktfile.close();
            }
            aktNumber++;
            if(aktNumber%10==0){
                QCoreApplication::processEvents();
            }
            if(onePercent!=0&&(aktNumber/onePercent)!=aktPercent){
                aktPercent=aktNumber/onePercent;
                importWindow->_setStatusProgressbar(aktPercent);
            }
            importWindow->_setStatus(QString::number(aktNumber)+"/"+QString::number(count));
            importWindow->_setTime(Timer.elapsed()/aktNumber*(count-aktNumber)/1000);
            if(importWindow->CancelImport){
                break;
            }

        }
    }
    file.close();
    if(!importWindow->CancelImport){
        _ListWidgetChanged();
        QFuture<void> future = QtConcurrent::run(this, &MainWindow::_fillListWidget);
    }
    importWindow->_setButtonText("Fertig");
    importWindow->_setStatusProgressbar(100);
    importWindow->_setTime(0);
    while(!importWindow->CancelImport){
        Sleep(10);
        QCoreApplication::processEvents();
    }
    importWindow->hide();
    importWindow->_setButtonText("Abbrechen");
}

QStringList MainWindow::_getBookInfosByISBN(QString ident){
    QStringList entrys;
    QNetworkAccessManager nam;
    if(ident.length()>10){
        ident=Isbn13to10(ident);
    }
    QNetworkReply * reply = nam.get(QNetworkRequest(QUrl("http://www.amazon.de/gp/product/"+ident)));
    QEventLoop loop;
    connect(reply, SIGNAL(finished()), &loop, SLOT(quit()));
    loop.exec();
    QString content=QString::fromUtf8(reply->readAll());
    QTextDocument doc;
    doc.setHtml(content);
    content=doc.toPlainText();
    QStringList tmp;
    QString data;
    //get author
    tmp=_stringBetween(content,"<div id=\"byline\" class=\"a-section a-spacing-micro bylineHidden feature\">","</div>");
    if(tmp.count()>0){
        QString data=tmp.at(0);
        tmp=_stringBetween(data,"<span class=\"a-size-medium\">","<span");
        if(tmp.count()>0){
            data=tmp.at(0);
            entrys.append(data);
        }
        else
            entrys.append("");
    }
    else
        entrys.append("");
    //get title
    tmp=_stringBetween(content,"<div class=\"a-section a-spacing-none\">","</div>");
    if(tmp.count()>0){
        data=tmp.at(0);
        tmp=_stringBetween(data,"<h1 id=\"title\"","</h1>");
        if(tmp.count()>0){
            data=tmp.at(0);
            tmp=_stringBetween(data,"<span","/span>");
            if(tmp.count()>0){
                data=tmp.at(0);
                tmp=_stringBetween(data,">","<");
                if(tmp.count()>0){
                    data=tmp.at(0);
                    entrys.append(data);
                }
                else
                    entrys.append("");
            }
            else
                entrys.append("");
        }
        else
            entrys.append("");
    }
    else
        entrys.append("");
    //get genre
    tmp=_stringBetween(content,"<ul class=\"a-horizontal a-size-small\">","</ul>");
    if(tmp.count()>0){
        data=tmp.at(0);
        tmp=_stringBetween(data,"<a class=\"a-link-normal a-color-tertiary\"","/a>");
        if(tmp.count()>0){
            data=tmp.last();
            tmp=_stringBetween(data,">","<");
            if(tmp.count()>0){
                data=tmp.at(0);
                entrys.append(data);
            }
            else
                entrys.append("");
        }
        else
            entrys.append("");
    }
    else
        entrys.append("");
    //get desc
    tmp=_stringBetween(content,"<noscript>","</noscript>");
    if(tmp.count()>0){
        data=tmp.at(0);
        tmp=_stringBetween(content,"<div>","</div>");
        if(tmp.count()>0){
            data=tmp.at(0);
            entrys.append(data);
        }
        else
            entrys.append("");
    }
    else
        entrys.append("");
    return entrys;
}

QString MainWindow::Isbn13to10(QString isbn13){
    if (isbn13.isNull())
        return "";
    isbn13 = isbn13.replace("-", "").replace(" ", "");
    if (isbn13.length() != 13)
        return "";
    QString isbn10 = isbn13.mid(3,9);
    int checksum = 0;
    int weight = 10;
    foreach(QChar c,isbn10)
    {
        checksum += (int)c.digitValue() * weight;
        weight--;
    }
    checksum = 11-(checksum % 11);
    if (checksum == 10)
        isbn10 += "X";
    else if (checksum == 11)
        isbn10 += "0";
    else
        isbn10 += QString::number(checksum);
    return isbn10;
}

QString MainWindow::_firstStringBetween(QString string,QString left,QString right){
    QStringList x=_stringBetween(string,left,right);
    if(x.count()>0){
        if(left.contains("identifier")){
            foreach(QString r,x) {
                if(r.contains("ISBN")){
                    x=_stringBetween(r,">","<");
                    if(x.count()>0){
                        QString l=x.at(0).split(":").last();
                        l.replace("'","`");
                        l.replace("\"","`");
                        return l;
                    }
                }
            }
            x=_stringBetween(x.at(0),">","<");
            if(x.count()>0){
                QString l=x.at(0).split(":").last();
                l.replace("'","`");
                l.replace("\"","`");
                return l;
            }
        }
        else{
            x=_stringBetween(x.at(0),">","<");
            if(x.count()>0){
                QString l=x.at(0);
                l.replace("'","`");
                l.replace("\"","`");
                return l;
            }
        }
    }
    return "";
}

QStringList MainWindow::_stringBetween(QString string,QString left,QString right){
    QStringList result;
    QStringList leftL=string.split(left);
    leftL.removeAt(0);
    foreach(QString l,leftL){
        QStringList rightL=l.split(right);
        if(rightL.count()>1){
            result.append(rightL.at(0));
        }
    }
    return result;
}

void MainWindow::on_actionImportiere_Datei_en_triggered()
{
    _importFiles();
}

void MainWindow::on_actionImportiere_Ordner_triggered()
{
    _importFolder();
}

void MainWindow::on_actionEinstellungen_triggered()
{
    settingsWindow=new SettingsGui();
    settingsWindow->setMain(this);
    settingsWindow->show();
    QSettings settings(GenreSettings, QSettings::IniFormat);
    settings.beginGroup("Genres");
    const QStringList KeyNames = settings.allKeys();
    foreach (const QString &childKey, KeyNames){
        QSettings settings(GenreSettings, QSettings::IniFormat);
        settings.beginGroup("Genres");
        QString tmp=settings.value(childKey).toString();
        settings.endGroup();
        tmp=tmp.right(tmp.length()-15);
        tmp=tmp.left(tmp.length()-2);
        tmp.replace("%' or subject LIKE '%",";");
        settingsWindow->addLWItem(childKey,tmp);
    }
    settings.endGroup();
}

void MainWindow::on_listWidget_itemSelectionChanged()
{
    _ListWidgetChanged();
}

void MainWindow::saveGenreSettings(QStringList data){
    bool changed;
    QSettings settings(GenreSettings, QSettings::IniFormat);
    settings.beginGroup("Genres");
    for(int i=0;i<data.count();i+=2){
        QString tmp=data.at(i+1);
        tmp.replace(";","%' or subject LIKE '%");
        tmp=QString("subject LIKE '%")+tmp+"%'";
        if(!(settings.value(data.at(i)).toString()==tmp)){
            settings.setValue(data.at(i),tmp);
            changed=true;
        }
    }
    QStringList tmp=settings.allKeys();
    foreach(QString key,tmp){
        if(!data.contains(key)){
            settings.remove(key);
            changed=true;
        }
    }
    bool showBookCount2=showBookCount;
    QSettings settingsI(Settings, QSettings::IniFormat);
    QString x=settingsI.value("General/LoadAllAtBegin","false").toString();
    if(settingsI.value("General/LoadGenreCounts","false").toString()=="true"){
        showBookCount=true;
    }
    else{
        showBookCount=false;
    }
    if(settingsI.value("General/openIntern","false").toString()=="true"){
        openIntern=true;
    }
    else{
        openIntern=false;
    }
    if(showBookCount2!=showBookCount || changed){
        QFuture<void> future = QtConcurrent::run(this, &MainWindow::_fillListWidget);
    }
    settingsI.endGroup();
}

void MainWindow::on_treeWidget_itemDoubleClicked(QTreeWidgetItem *item, int column)
{
    _openBook(item);
}
