#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include <QMainWindow>
#include <QListWidgetItem>
#include <QTreeWidgetItem>
#include <QListWidget>
#include <QTextStream>
#include <QSettings>
#include <QtSql/QtSql>
#include <QStandardItemModel>
#include <QListView>
#include <QtConcurrent>
#include <QMouseEvent>
#include <QFutureWatcher>
#include <QClipboard>
#include <editwindow.h>
#include <sql_konsole.h>
#include <QtGui>
//#include "qzip.h"
#include <importwindow.h>
#include <QCoreApplication>
#include <QByteArray>
#include <QBitArray>
#include <QString>
#include <QDebug>
#include <QFile>
#include <QList>
#include <settingsgui.h>
#include <QMenu>
#include <QtNetwork>

class EditWindow;
class ImportWindow;
class SQL_Konsole;
class SettingsGui;

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    QFuture<void> SqlLoadingThread;
    Ui::MainWindow *ui;
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void _ListWidgetChanged();
    void _fillListWidget();
    QList<QStringList> _getSqlArray(QString Sql);
    void _getSqlArrayMT(QString Sql);
    void _fillListView(QList<QStringList> list, bool headers, bool changeSize);
    void _msg(QString msg);
    void _fillTreeWithList(QStringList selListWidget);
    bool eventFilter(QObject *obj, QEvent *event);
    void _openBook(QTreeWidgetItem *item, int opt);
    QString _getTreeWidgetItemGlobalPath(QTreeWidgetItem* item);
    bool showBookCount=false;
    bool openIntern=false;
    void _SqlExec(QString Sql);
    void _Error(QString msg);
    QString Settings;
    QString GenreSettings;
    void _importFolder();
    void _importFiles();
    bool _unzip(QString PathFrom, QString PathTo, int time);
    QStringList _getFiles(QString path);
    void _importToDb();
    void _import(QStringList files);
    void clearImportFolders();
    QStringList _stringBetween(QString string,QString left,QString right);
    QString _firstStringBetween(QString string,QString left,QString right);
    void saveGenreSettings(QStringList data);
private slots:
    void on_comboBox_currentIndexChanged(const QString &arg1);
    void on_comboBox_2_currentIndexChanged(int index);
    void on_pushButton_clicked();
    void on_listWidget_itemClicked(QListWidgetItem *item);
    void on_listWidget_itemDoubleClicked(QListWidgetItem *item);
    void on_pushButton_2_clicked();
    void on_pushButton_3_clicked();
    void on_treeWidget_itemClicked(QTreeWidgetItem *item, int column);
    void on_treeWidget_customContextMenuRequested(const QPoint &pos);
    void on_treeWidgetContextRead();
    void on_treeWidgetContextOpen();
    void on_treeWidgetContextOpenFolder();
    void on_treeWidgetContextEdit();
    void on_treeWidgetContextCopyPath();
    void on_treeWidgetContextDeleteDB();
    void on_treeWidgetContextDelete();
    void on_treeWidget_itemSelectionChanged();
    void on_actionLesen_triggered();
    void on_actionAlleB_cher_aus_der_Datenbank_entfernen_triggered();
    void on_action_ndere_alle_B_cher_zum_kompletten_Pfad_triggered();
    void on_action_ndere_den_Pfad_aller_B_cher_wenn_m_glich_zu_einem_Pfad_relativ_zum_Programm_triggered();
    void on_action_ndere_den_Pfad_aller_B_cher_notfalls_mit_verschieben_triggered();
    void on_actionSQL_Konsole_vorsichtig_nutzen_triggered();
    void on_actionImportiere_Datei_en_triggered();
    void on_actionImportiere_Ordner_triggered();
    void on_actionEinstellungen_triggered();
    void on_listWidget_itemSelectionChanged();
    void on_treeWidget_itemDoubleClicked(QTreeWidgetItem *item, int column);
protected:
    void mouseMoveEvent ( QMouseEvent *event ) ;
    void mousePressEvent ( QMouseEvent * event ) ;
    void closeEvent( QCloseEvent *event );
private:
    bool popup=false;
    bool selected=false;
    QString aktImage;
    QString lastSqlSubject;
    void on_RateImage_clicked();
    void on_RateImageU_clicked(int y);
    void ImageHovered(int HoverY);
    QString Isbn13to10(QString isbn13);
    QStringList _getBookInfosByISBN(QString ident);
    EditWindow *editWindow;
    SQL_Konsole *SQL_KONSOLE;
    ImportWindow *importWindow;
    QStringList RatingStars;
    QString tempRead;
    QString XMLs;
    SettingsGui *settingsWindow;
};

#endif // MAINWINDOW_H
