#include "settingsgui.h"
#include "ui_settingsgui.h"

SettingsGui::SettingsGui(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::SettingsGui)
{
    ui->setupUi(this);
    ui->twData->clear();
    ui->twData->setColumnCount(2);
    QTreeWidgetItem *Head = new QTreeWidgetItem(0);
    ui->twData->setColumnWidth(0,140);
    Head->setText(0, "Name");
    ui->twData->setColumnWidth(1,390);
    Head->setText(1, "Kriterien");
    ui->twData->setHeaderItem(Head);
    QSettings settings(QCoreApplication::applicationDirPath()+"/Data/Settings/settings.ini", QSettings::IniFormat);
    settings.beginGroup("General");
    if(settings.value("LoadAllAtBegin","false").toString()=="true")
        ui->sJa->setChecked(true);
    else
        ui->sNein->setChecked(true);
    if(settings.value("LoadGenreCounts","true").toString()=="true")
        ui->gJa->setChecked(true);
    else
        ui->gNein->setChecked(true);
    if(settings.value("openIntern","true").toString()=="true")
        ui->iJa->setChecked(true);
    else
        ui->iNein->setChecked(true);
    settings.endGroup();
    ui->twData->setContextMenuPolicy(Qt::CustomContextMenu);
    //connect(ui->twData, SIGNAL(customContextMenuRequested(QPoint)),this, SLOT(on_twData_customContextMenuRequested(QPoint)));
}

void SettingsGui::setMain(MainWindow *x){
    mw=x;
}

void SettingsGui::addLWItem(QString name,QString krit){
    QTreeWidgetItem *testItem = new QTreeWidgetItem(ui->twData);
    testItem->setText(0, name);
    testItem->setText(1, krit);
    QSize size=testItem->sizeHint(0);
    size.setHeight(20);
    testItem->setSizeHint(0,size);
    size=testItem->sizeHint(1);
    size.setHeight(20);
    testItem->setSizeHint(1,size);
    ui->twData->scrollToItem(testItem);
    ui->twData->addTopLevelItem(testItem);
}

SettingsGui::~SettingsGui()
{
    delete ui;
}

void SettingsGui::on_pushButton_clicked()
{
    QStringList data;
    for(int i=0;i<ui->twData->topLevelItemCount();i++){
        for(int l=0;l<ui->twData->columnCount();l++){
            data<<ui->twData->topLevelItem(i)->text(l);
        }
    }
    QSettings settings(QCoreApplication::applicationDirPath()+"/Data/Settings/settings.ini", QSettings::IniFormat);
    settings.beginGroup("General");
    if(ui->sJa->isChecked())
        settings.setValue("LoadAllAtBegin","true");
    else
        settings.setValue("LoadAllAtBegin","false");
    if(ui->gJa->isChecked())
        settings.setValue("LoadGenreCounts","true");
    else
        settings.setValue("LoadGenreCounts","false");
    if(ui->iJa->isChecked())
        settings.setValue("openIntern","true");
    else
        settings.setValue("openIntern","false");
    settings.endGroup();
    settings.sync();
    mw->saveGenreSettings(data);
    delete this;
}

void SettingsGui::on_treeWidgetContextEdit(){
    QTreeWidgetItem *tmp=ui->twData->currentItem();
    if(tmp!=NULL){
        ui->eName->setText(tmp->text(0));
        ui->eKret->setText(tmp->text(1));
    }
}

void SettingsGui::on_treeWidgetContextDel(){
    delete ui->twData->currentItem();
}

void SettingsGui::on_pushButton_2_clicked()
{
    delete this;
}

void SettingsGui::on_twData_customContextMenuRequested(const QPoint &pos)
{
    QMenu *menu=new QMenu(this);
    menu->addAction(QString("Bearbeiten"), this,SLOT(on_treeWidgetContextEdit()));
    menu->addAction(QString("Löschen"), this,SLOT(on_treeWidgetContextDel()));
    menu->popup(ui->twData->viewport()->mapToGlobal(pos));
}

void SettingsGui::on_bInsert_clicked()
{
    if(ui->eName->text()!="" || ui->eKret->text()!=""){
        QString krit=ui->eKret->text();
        krit.replace("'","`");
        QList<QTreeWidgetItem *> tmp=ui->twData->findItems(ui->eName->text(),Qt::MatchExactly,0);
        if(tmp.count()>0){
            tmp.first()->setText(1,krit);
            ui->twData->scrollToItem(tmp.first());
        }
        else{
            addLWItem(ui->eName->text().replace("'","`"),krit);
        }
    }
    else{
        mw->_msg("Name und Kriterium dürfen nicht leer sein!");
    }
}
